package BowlingGame;

import org.junit.Test;
import static org.junit.Assert.*;
import org.junit.Before;

// canCreateGame
// canRoll
// setUp -> private Game g
// gutterGame -> return -1, then return 0
// allOnes -> return 20? -> + private int score = 0; score+=pins;
// duplicate -> rollMany
// oneSpare -> wrong design -> @Ignore this and refactor roll and score
// score: index -> frames -> extract isSpare()
// rollSpare()
// oneStrike()
// score: isStrike() feltétel, +isStrike() kiemelése,
// score: nextTwoBallsForStrike
// score: nextBallForSpare
// score: twoBallsInFrame
// +perfectGame
// Done! :)

public class BowlingTest {
    
    private Game g; // 3. 
    
    @Before
    public void setUp() throws Exception {
        g = new Game(); // 3.
    }

    /*
    // 1.
    @Test
    public void canCreateGame() throws Exception {
        Game g = new Game();
    }
*/
    
    // 2.
    @Test
    public void canRoll() throws Exception{
        Game g = new Game();
        g.roll(0);
    }
    
    // 4.
    @Test
    public void gutterGame() {
        /*
        for (int i = 0; i < 20; i++){
            g.roll(0);
        }*/
        rollMany(20, 0);
        assertEquals(0, g.score());
    }
    
    // 5.
    @Test
    public void allOnes() { 
        /*
        for (int i = 0; i < 20; i++){
            g.roll(1);
        } */
        rollMany(20, 1);
        assertEquals(20, g.score());
    }
    
    
    public void rollMany(int n, int pins) {
        for (int i = 0; i < n; i++){
            g.roll(pins);
        }        
    }
    
    @Test
    public void oneSpare() {
        //g.roll(5);
        //g.roll(5); // spare
        rollSpare();
        g.roll(3);
        rollMany(17, 0);
        assertEquals(16, g.score());
    }
    
    private void rollSpare(){
        g.roll(5);
        g.roll(5); 
    }
    
    @Test
    public void oneStrike() {
        g.roll(10);
        g.roll(3); 
        g.roll(4);
        rollMany(16, 0);
        assertEquals(24, g.score());
    }
    
    @Test
    public void perfectGame() {
        rollMany(12, 10);
        assertEquals(300, g.score());
    }
}
